/**********************************************************
 * typedefs
 **********************************************************/

typedef pascal void (*STAProcPtr) (long, short);
typedef pascal long (*GTAProcPtr) (short);
typedef pascal short (*WNEProcPtr) (short, EventRecord *, long, RgnHandle);
typedef pascal short (*GNEProcPtr) (short, EventRecord *);
typedef pascal void (*ICProcPtr) (void);
typedef pascal void (*DMBProcPtr) (void);
typedef pascal void (*ERProcPtr) (Rect *);
typedef pascal void (*EOProcPtr) (Rect *);
typedef pascal void (*EGProcPtr) (RgnHandle);
typedef pascal void (*STProcPtr) (void);
typedef pascal long (*SRProcPtr) (Handle);

typedef struct {
        char    privates[76];
        long    randSeed;
        BitMap  screenBits;
        Cursor  arrow;
        Pattern dkGray;
        Pattern ltGray;
        Pattern black;
        Pattern white;
        GrafPtr thePort;
        long    qdend;
} QDGlobals;

typedef struct PatchGlobals {
	STAProcPtr		pgOldSTA;			// address of old SetTrapAddress
	GTAProcPtr		pgOldGTA;			// address of old GetTrapAddress
	WNEProcPtr		pgOldWNE;			// address of old WaitNextEvent
	GNEProcPtr		pgOldGNE;			// address of old GetNextEvent
	ICProcPtr		pgOldIC;			// address of old InitCursor
	DMBProcPtr		pgOldDMB;			// address of old DrawMenuBar
	ERProcPtr		pgOldER;			// address of old EraseRect
	EOProcPtr		pgOldEO;			// address of old EraseOval
	EGProcPtr		pgOldEG;			// address of old EraseRgn
	STProcPtr		pgOldST;			// address of old SystemTask
	Boolean			pgSaverOn,			// Are we asleep?
					pgPatchesIn,		// Are the sleepy-time patches set?
					pgInSleepRect,		// Is the mouse in the sleep rect?
					pgMustSleep,		// Do we need to fall asleep now?
					pgBouncingClock,	// Should there be a bouncing clock?
					pgMenubarKluge,		// Should we play with the menu bar?
					pgMustSave;			// Are we turned on?
	short			pgSleepRect,		// index number of the sleep rect
					pgWakeRect,			// index number of the wake rect
					pgOldHeight;		// old menu bar height
	long			pgRefreshTime,		// ticks between refreshes
					pgLastAction,		// time of last user action
					pgIdleTicks,		// idle ticks before sleep
					pgLastRefresh;		// time of last refresh
	Point			pgLastMouse;		// point mouse was last at
	Rect			pgCorners[4];		// corners of the main screen (rects)
	Pattern			pgForePat,			// foreground pattern
					pgBackPat;			// background pattern
	PicHandle		pgClockBg;			// clock background picture
} PatchGlobals, *PatchGlobalsPtr;