
Verb	table.move
Syntax	table.move (addr1, addr2)
Parameters	addr1 is the Object Database address indicating the location of the object to be moved.
addr2 is the Object Database address of a table where the object at addr1 is to be moved.
Action	Moves the object at addr1 to the table at addr2.
Returns	True
Examples	The examples table contains a table called table1 with four entries: a string, a number, a script, and an outline. It also has an empty table called table2. The following line moves the outline from table1 into table2:
	table.move (@examples.table1.entry4, @examples.table2)
		 true
Select table2 in the table window and youll see that it now has one item. Open it and youll see that its one item is called entry4 and that it has the same contents as examples.table1.entry4. Open table1 and youll notice that there is no entry4.
Errors	 Attempting to move an object to a non-existent addr2 results in an error.
 If addr2 contains any object other than a table, an error message is generated.
See Also	table.copy
table.moveAndRename
table.moveContents
